﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml;
using System.Xml.Xsl;
using System.Xml.XPath;
using System.IO;


namespace ProNvest.Retail.Common
{
   //This Constructor for this object will take the XML returned from signix and load it into the object.
   class SignixDocumentResponse
   {
      #region MemberVariables
      private String _statusCode = String.Empty;
      private String _statusDesc = String.Empty;

      private String _documentSetId = String.Empty;
      private String _pickUpToken = String.Empty;
      private String _pickUpLink = String.Empty;
      #endregion

      #region Properties
      public String StatusCode
      {
         get { return _statusCode; }
         set { _statusCode = value; }
      }
      public String StatusDesc
      {
         get { return _statusDesc; }
         set { _statusDesc = value; }
      }

      public String DocumentSetId
      {
         get { return _documentSetId; }
         set { _documentSetId = value; }
      }
      public String PickUpToken
      {
         get { return _pickUpToken; }
         set { _pickUpToken = value; }
      }
      public String PickUpLink
      {
         get { return _pickUpLink; }
         set { _pickUpLink = value; }
      }
      #endregion

      #region Constructors

      public SignixDocumentResponse( String ResponseXML )
      {
         XmlDocument xdoc = new XmlDocument();
         xdoc.LoadXml( ResponseXML );
         //_statusCode = xdoc.GetElementsByTagName( "StatusCode" ).
         //_statusDesc = xdoc.GetElementsByTagName( "StatusDesc" ).ToString();

         XmlElement root = xdoc.DocumentElement;
         XmlNodeList xlist = root.GetElementsByTagName( "StatusCode" );
         if (xlist.Count != 0)
         {
            _statusCode = xlist[0].InnerText;
         }
         
         xlist = root.GetElementsByTagName( "StatusDesc" );
         if (xlist.Count != 0)
         {
            _statusDesc = xlist[0].InnerText;
         }

         xlist = root.GetElementsByTagName( "DocumentSetID" );
         if (xlist.Count != 0)
         {
            _documentSetId = xlist[0].InnerText;
         }

         xlist = root.GetElementsByTagName( "PickupToken" );
         if (xlist.Count != 0)
         {
            _pickUpToken = xlist[0].InnerText;
         }

         xlist = root.GetElementsByTagName( "PickupLink" );
         if (xlist.Count != 0)
         {
            _pickUpLink = xlist[0].InnerText;
         }


         //XmlElement stat = (XmlElement)xdoc.SelectSingleNode( "Status" );
         //XmlElement statcode = (XmlElement)stat.SelectSingleNode( "StatusCode" );
         //_statusCode = statcode.InnerText;

         //XmlReader xreader = XmlReader.Create( new System.IO.StringReader( ResponseXML ) );


         //_statusCode = xreader.ReadElementString( "<StatusCode>" );
         //_statusDesc = xreader.ReadElementString( "StatusDesc" );


      }

      #endregion

     

   }
}
