﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Configuration;
using System.Web;
using System.Net;
using System.Xml;
using System.Xml.Xsl;
using System.Xml.XPath;



namespace ProNvest.Retail.Common.Signix
{
   public class SignixTransportService
   {
      public SignixTransportService()
      {
         //empty constructor
      }


    
      //Submits the XML file to signix for the given method.  Then the signix return XML.  
      public String PostFileToSignix( String signixMethod, String FileContent )
      {
         StringBuilder sb = new StringBuilder();
         //TODO: Add an application key for SignixPostURL and set it to the URL to be used from the given system
         String postURL = ConfigurationManager.AppSettings["SignixPostURL"].ToString();
         sb.Append( "method=" );
         sb.Append( HttpUtility.UrlEncode( signixMethod, Encoding.UTF8 ) );
         sb.Append( "&request=" );
         sb.Append( HttpUtility.UrlEncode( FileContent, Encoding.UTF8 ) );
         String postString = sb.ToString();


         //create WebRequest to communicate with Signix
         HttpWebRequest request = (HttpWebRequest)WebRequest.Create( postURL );
         request.Method = "POST";
         request.ContentLength = postString.Length;
         request.ContentType = "application/x-www-form-urlencoded";
         //request.ContentType = "text/xml";

         //Write request to Signinx
         StreamWriter writer = new StreamWriter( request.GetRequestStream() );
         writer.Write( postString );
         writer.Close();

         //ReadREsponse From Signix
         String signixRepsonse = String.Empty;
         HttpWebResponse response = (HttpWebResponse)request.GetResponse();
         StreamReader reader = new StreamReader( response.GetResponseStream() );
         signixRepsonse = reader.ReadToEnd();
         reader.Close();

         SignixDocumentResponse docResponse = new SignixDocumentResponse( signixRepsonse );
         return docResponse.StatusCode;

      }
   }
}
