package com.netcertainty.client.b2b;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.HttpURLConnection;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URLEncoder;

public class SDDHttpPost
{
	public static final String B2B_ENTRY_POINT_PATH = "/sdd/b2b/sdddc_ns.jsp";
	
    public static String doService(String host, String methodId, String requestXML)
    throws IOException, URISyntaxException
    {
    	return doService(new URI(host + B2B_ENTRY_POINT_PATH), methodId, requestXML);
    }
    
    public static String doService(URI uri, String methodId, String requestXML)
    throws IOException
    {
        HttpURLConnection con = submit(uri, methodId, requestXML);
        
        String result = getResponse(con);
        //System.out.println(result);
        
        return result;
    }
    
    
    public static HttpURLConnection submit(URI port, String method, String requestXML)
    throws IOException
    {
        HttpURLConnection con = (HttpURLConnection) port.toURL().openConnection();
        con.setDoOutput(true);
        con.setRequestMethod("POST");
        con.connect();
        PrintWriter out = new PrintWriter(con.getOutputStream());
        out.print("method=" + URLEncoder.encode(method, "UTF-8"));
        out.print("&request=" + URLEncoder.encode(requestXML, "UTF-8"));
        out.close();
        return con;
    }
    
    
    public static String getResponse(HttpURLConnection con)
    throws IOException
    {
        StringBuilder result = new StringBuilder();

        InputStream responseStream = con.getInputStream();
        BufferedReader responseReader = new BufferedReader(new InputStreamReader(responseStream));
        try
        {
            int c;
            while ((c = responseReader.read()) != -1) result.append((char) c);
        }
        finally
        {
            responseReader.close();
        }
        
        return result.toString();
    }
}
